package sun.awt.windows;

import java.awt.Checkbox;
import java.awt.CheckboxGroup;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Event;
import java.awt.FontMetrics;
import java.awt.peer.CheckboxPeer;

public class WCheckboxPeer extends WComponentPeer implements CheckboxPeer {
   native void create(WComponentPeer var1);

   public native void setLabel(String var1);

   void initialize() {
      Checkbox t = (Checkbox)super.target;
      this.setState(t.getState());
      this.setCheckboxGroup(t.getCheckboxGroup());
      this.setLabel(t.getLabel());
      super.initialize();
   }

   public WCheckboxPeer(Checkbox target) {
      super(target);
   }

   public native void setState(boolean var1);

   public native void setCheckboxGroup(CheckboxGroup var1);

   public Dimension minimumSize() {
      String lbl = ((Checkbox)super.target).getLabel();
      if (lbl != null) {
         FontMetrics fm = ((WComponentPeer)this).getFontMetrics(super.target.getFont());
         return new Dimension(30 + fm.stringWidth(lbl), Math.max(fm.getHeight() + 8, 15));
      } else {
         return new Dimension(20, 15);
      }
   }

   void handleAction(long time, int msgData, boolean state) {
      Checkbox target = (Checkbox)super.target;
      target.setState(state);
      ((Component)target).postEvent(new Event(target, 1001, new Boolean(state)));
   }
}
