package sun.awt.windows;

import java.awt.Event;
import java.awt.Frame;
import java.awt.Image;
import java.awt.MenuBar;
import java.awt.peer.FramePeer;
import sun.awt.image.ImageRepresentation;

class WFramePeer extends WWindowPeer implements FramePeer {
   native void create(WComponentPeer var1);

   public native void setTitle(String var1);

   public void setIconImage(Image im) {
   }

   public native void setMenuBar(MenuBar var1);

   public native void setResizable(boolean var1);

   public native void setCursor(int var1);

   native void widget_setIconImage(ImageRepresentation var1);

   WFramePeer(Frame target) {
      super(target);
      if (target.getTitle() != null) {
         this.setTitle(target.getTitle());
      }

      Image icon = target.getIconImage();
      if (icon != null) {
         this.setIconImage(icon);
      }

      if (target.getCursorType() != 0) {
         this.setCursor(target.getCursorType());
      }

      this.setResizable(target.isResizable());
   }

   public void handleIconify(long when) {
      super.target.postEvent(new Event(super.target, 203, (Object)null));
   }

   public void handleDeiconify(long when) {
      super.target.postEvent(new Event(super.target, 204, (Object)null));
   }

   protected void handleMoved(long when, int data, int x, int y) {
      super.target.postEvent(new Event(super.target, 0L, 205, x, y, 0, 0));
   }

   protected void handleResize(long when, int u1, int width, int height, int u4, int u5) {
      super.target.invalidate();
      super.target.validate();
      super.target.repaint();
   }
}
